      SUBROUTINE PZGESV2( TRANS, N, NRHS, A, IA, JA, DESCA,
     $                    IPIV, B, IB, JB, DESCB, RCOND,
     $                    WORK, LWORK, RWORK, LRWORK, INFO )
*
* Scalar Arguments
      CHARACTER          TRANS
      INTEGER            IA, IB, INFO, JA, JB,
     $                   LRWORK, LWORK, N, NRHS
      DOUBLE PRECISION   RCOND
*
* Array Arguments
      INTEGER            DESCA( * ), DESCB( * ), IPIV( * )
      DOUBLE COMPLEX     A( * ), B( * ), WORK( * )
      DOUBLE PRECISION   RWORK( * )
*
* Parameters
      INTEGER            BLOCK_CYCLIC_2D, CSRC_, CTXT_, DLEN_, DTYPE_,
     $                   LLD_, MB_, M_, NB_, N_, RSRC_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                     CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                     RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*
* Local Scalars
      LOGICAL            LQUERY, NOTRAN
      CHARACTER          NORM
      INTEGER            CONWRK, I, IACOL, IAROW, IBROW, IBCOL,
     $                   ICOFFA, ICOFFB, ICTXT, IIA, IIB,
     $                   IROFFA, IROFFB, J, JJA, JJB,
     $                   LRWMIN, LWMIN, MYCOL, MYROW, NP, NPCOL, NPROW
*
      DOUBLE PRECISION   ANORM, COLCND, RCMAX, RCMIN, ROWCND
*
* Local Arrays
      INTEGER            IDUM1( 3 ), IDUM2( 3 )
*
* External Subroutines
      EXTERNAL           BLACS_GRIDINFO, CHK1MAT, DESCSET, PCHK2MAT,
     $                   INFOG2L, PZGECON, PZGETRF, PZGETRS,
     $                   PZLACPY, PZLAQGE, PXERBLA
*
* External Functions
      LOGICAL            LSAME
      INTEGER            ICEIL, ILCM, INDXG2P, NUMROC
      DOUBLE PRECISION   PDLAMCH, PZLANGE
      EXTERNAL           ICEIL, ILCM, INDXG2P, LSAME, NUMROC, PZLANGE,
     $                   PDLAMCH
*
* Intrinsic Functions
      INTRINSIC          DBLE, ICHAR, MAX, MOD
*
* Executable Statements
*
* Get grid parameters
*
      ICTXT = DESCA( CTXT_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* Test the input parameters
*
      INFO = 0
      IF( NPROW.EQ.-1 ) THEN
         INFO = -(700+CTXT_)
      ELSE
         CALL CHK1MAT( N, 2, N, 2, IA, JA, DESCA, 7, INFO )
*
         CALL CHK1MAT( N, 2, NRHS, 3, IB, JB, DESCB, 12, INFO )
*
         NOTRAN = LSAME( TRANS, 'N' )
*
         IF( INFO.EQ.0 ) THEN
            IAROW = INDXG2P( IA, DESCA( MB_ ), MYROW, DESCA( RSRC_ ),
     $                       NPROW )
            IBROW = INDXG2P( IB, DESCB( MB_ ), MYROW, DESCB( RSRC_ ),
     $                       NPROW )
            IROFFA = MOD( IA-1, DESCA( MB_ ) )
            ICOFFA = MOD( JA-1, DESCA( NB_ ) )
            IROFFB = MOD( IB-1, DESCB( MB_ ) )
            ICOFFB = MOD( JB-1, DESCB( NB_ ) )
*
            CALL INFOG2L( IA, JA, DESCA, NPROW, NPCOL, MYROW,
     $                    MYCOL, IIA, JJA, IAROW, IACOL )
            NP = NUMROC( N+IROFFA, DESCA( MB_ ), MYROW, IAROW,
     $                   NPROW )
            IF( MYROW.EQ.IAROW )
     $         NP = NP-IROFFA
            NQ = NUMROC( N+ICOFFA, DESCA( NB_ ), MYCOL, IACOL,
     $                   NPCOL )
            IF( MYCOL.EQ.IACOL )
     $         NQ = NQ-ICOFFA
*
            CONWRK = 2*NP + 2*NQ + MAX( 2, MAX( DESCA( NB_ )*
     $               MAX( 1, ICEIL( NPROW-1, NPCOL ) ), NQ +
     $               DESCA( NB_ )*
     $               MAX( 1, ICEIL( NPCOL-1, NPROW ) ) ) )
*
            LWMIN = CONWRK
            WORK( 1 ) = DBLE( LWMIN )
            LRWMIN = MAX( 2*NQ, NP )
            RWORK( 1 ) = DBLE( LRWMIN )
*
            IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND.
     $         .NOT. LSAME( TRANS, 'C' ) ) THEN
               INFO = -1
            ELSE IF( IROFFA.NE.0 ) THEN
               INFO = -5
            ELSE IF( ICOFFA.NE.0 .OR. IROFFA.NE.ICOFFA ) THEN
               INFO = -6
            ELSE IF( DESCA( MB_ ).NE.DESCA( NB_ ) ) THEN
               INFO = -(700+NB_)
            ELSE
            END IF
*
         END IF
*
         WORK( 1 ) = DBLE( LWMIN )
         RWORK( 1 ) = DBLE( LRWMIN )
         LQUERY = ( LWORK.EQ.-1 .OR. LRWORK.EQ.-1 )
         IF( INFO.EQ.0 ) THEN
            IF( IBROW.NE.IAROW ) THEN
               INFO = -10
            ELSE IF( DESCB( MB_ ).NE.DESCA( NB_ ) ) THEN
               INFO = -(1200+NB_)
            ELSE IF( ICTXT.NE.DESCB( CTXT_ ) ) THEN
               INFO = -(1200+CTXT_)
            ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
               INFO = -15
            ELSE IF( LRWORK.LT.LRWMIN .AND. .NOT.LQUERY ) THEN
               INFO = -17
            END IF
            IDUM1( 1 ) = ICHAR( TRANS )
            IDUM2( 1 ) = 1
*
               IF( LWORK.EQ.-1 ) THEN
                  IDUM1( 2 ) = -1
               ELSE
                  IDUM1( 2 ) = 1
               END IF
               IDUM2( 2 ) = 15
               IF( LRWORK.EQ.-1 ) THEN
                  IDUM1( 3 ) = -1
               ELSE
                  IDUM1( 3 ) = 1
               END IF
               IDUM2( 3 ) = 17
               CALL PCHK2MAT( N, 2, N, 2, IA, JA, DESCA, 7, N, 2,
     $                        NRHS, 3, IB, JB, DESCB, 12, 3, IDUM1,
     $                        IDUM2, INFO )
*            END IF
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( ICTXT, 'PZGESV2', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
* Compute the norm of the matrix A.
*
      IF( NOTRAN ) THEN
         NORM = '1'
      ELSE
         NORM = 'I'
      END IF
      ANORM = PZLANGE( NORM, N, N, A, IA, JA, DESCA, RWORK )
*
* Compute the LU factorization of A.
*
         CALL PZGETRF( N, N, A, IA, JA, DESCA, IPIV, INFO )
*
* Return if INFO .NE. 0
*
         IF( INFO.NE.0 ) THEN
            IF( INFO.GT.0 )
     $         RCOND = ZERO
            RETURN
         END IF
*
* Compute the reciprocal of the condition number of A.
*
      CALL PZGECON( NORM, N, A, IA, JA, DESCA, ANORM, RCOND, WORK,
     $              LWORK, RWORK, LRWORK, INFO )
*
* Return if the matrix is singular to working precision.
*
      IF( RCOND.LT.PDLAMCH( ICTXT, 'Epsilon' ) ) THEN
         INFO = IA + N
         RETURN
      END IF
*
* Compute the solution matrix X.
*
      CALL PZGETRS( TRANS, N, NRHS, A, IA, JA, DESCA, IPIV, B, IB,
     $              JB, DESCB, INFO )
*
      WORK( 1 ) = DBLE( LWMIN )
      RWORK( 1 ) = DBLE( LRWMIN )
*
      RETURN
*
*     End of PZGESV2
*
      END
